"use server";

import { getServerSession } from "next-auth";
import { database, setUserPassword } from "./db";
import { isAdmin } from "./util";

export async function fetchAllUsers(): Promise<string[]> {
  return new Promise((resolve, reject) => {
    if (!isAdmin) return reject("Unauthenticated");

    const db = database();
    db.all("SELECT key FROM passwords", (err, res: any) => {
      if (err) return reject(err);

      resolve(res.map((row: any) => row.key));
    });
  });
}

export async function changeOwnPassword(newPass: string) {
  if (newPass.length < 8) throw new Error("Invalid password");
  const session = await getServerSession();
  if (!session?.user?.email) throw new Error("Unauthenticated");
  await setUserPassword(session.user.email, newPass);
}
